
#include "mammut.h"
#include "play.h"

#include <sndlib.h>


/* Only call once per process. */
bool InitPlay(void){
  mus_sound_initialize();
  return true;
}

struct Sndplay{
  int outport;
  int samples_per_frame;
};

void *OpenPlay(int spf,int samplerate){
  struct Sndplay *sndplay;
  sndplay=malloc(sizeof(struct Sndplay));

  sndplay->outport = mus_audio_open_output(MUS_AUDIO_DEFAULT, samplerate, spf, MUS_COMPATIBLE_FORMAT, 1024);

  if(sndplay->outport==-1){
    free(sndplay);
    fprintf(stderr,"Could not open sndlib outport.\n");
    return NULL;
  }

  sndplay->samples_per_frame=spf;

  return sndplay;
}

void WritePlay(
	       void *port,float **samples,int num_samples
	       )
{
  struct Sndplay *sndplay=(struct Sndplay *)port;
  int i,ch;
  int16_t framebuff[num_samples*sndplay->samples_per_frame];

  for (i=0; i<num_samples; i++) {
    for (ch=0; ch<sndplay->samples_per_frame; ch++)
      *(framebuff+i*sndplay->samples_per_frame+ch)=(short)(samples[ch][i]*32767.);
  }
  
  mus_audio_write(sndplay->outport,(char*)framebuff,num_samples*2*sndplay->samples_per_frame);

}


void ClosePlay(void *port){
  struct Sndplay *sndplay=(struct Sndplay *)port;
  mus_audio_close(sndplay->outport);
  free(sndplay);
}


